﻿using Microsoft.AspNetCore.Mvc;
using AutoMapperProjectionsWithEntityFrameworkCore.Data;
using System.Linq;
using AutoMapper;
using AutoMapperInstanceProjectionsWithEntityFrameworkCore.Models;
using AutoMapper.QueryableExtensions;

namespace AutoMapperProjectionsWithEntityFrameworkCore.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class ProductsController : ControllerBase
    {
        private readonly SalesContext _salesContext;
        private readonly IMapper _mapper;

        public ProductsController (SalesContext salesContext, IMapper mapper)
        {
            _salesContext = salesContext;
            _mapper = mapper;
        }

        [HttpGet("{count}")]
        public ActionResult Get(int count)
        {
            return Ok(_salesContext.Products.OrderBy(p => p.ProductId).Take(count));
        }

        [HttpGet("projected/{count}")]
        public ActionResult GetProjected(int count)
        {
            return Ok(_mapper.ProjectTo<ProductModel>(_salesContext.Products.Take(count).OrderBy(p => p.ProductId).Take(count)));
        }

    }
}
